Attribute VB_Name = "APIStuff"
Option Explicit

Public OldWindowProc As Long

Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_USER = &H400
' Return this control's class name.
Public Function ClassName(ByVal hwnd As Long) As String
Dim buf As String
Dim buflen As Long

    buflen = 256
    buf = Space$(buflen - 1)
    buflen = GetClassName(hwnd, buf, buflen)
    ClassName = Left$(buf, buflen)
End Function
' Return the hWnd of this control's Edit control child.
Public Function FindEditChild(ByVal hwnd As Long) As Long
Const GW_CHILD = 5
Const GW_HWNDNEXT = 2
Dim child_hwnd As Long

    child_hwnd = GetWindow(hwnd, GW_CHILD)
    Do While child_hwnd <> 0
        If ClassName(child_hwnd) = "Edit" Then
            FindEditChild = child_hwnd
            Exit Function
        End If

        child_hwnd = GetWindow(child_hwnd, GW_HWNDNEXT)
    Loop

    FindEditChild = 0
End Function


' Pass along all messages except the one that
' makes the context menu appear.
Public Function NoPopupWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_CONTEXTMENU = &H7B

    If msg <> WM_CONTEXTMENU Then _
        NoPopupWindowProc = CallWindowProc( _
            OldWindowProc, hwnd, msg, wParam, _
            lParam)
End Function
